import RPi.GPIO as GPIO
import time
import os
import errno
from pythonosc import osc_message_builder
from pythonosc import udp_client

time.sleep(10) # warten bis WLAN da ist

empty = '0'
pins = [empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty]
order = [23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8]
msgAdd = ""
_FILENAME = "/home/pi/Desktop/hierDieSonicPiIPAdresseRein.txt"


GPIO.setmode(GPIO.BCM)

GPIO.cleanup()

GPIO.setup(8, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(9, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(10, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(11, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)

GPIO.setup(12, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(13, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(14, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(15, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)

GPIO.setup(16, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(17, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(18, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(19, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)

GPIO.setup(20, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(21, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(22, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(23, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)

GPIO.setup(24, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(25, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(26, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(27, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)


os.system("clear")

def checkIP():
    filename = _FILENAME
    if not os.path.isfile(filename):
        ipNummer = input("Sonic Pi IP Nummer?")
        if ipNummer != "" and ipNummer:
            try:
                os.makedirs(os.path.dirname(filename))
            except OSError as exc: # Guard against race condition
                if exc.errno != errno.EEXIST:
                   raise

            f = open(filename, "w")
            f.write(ipNummer)
            print (os.path.exists(filename))
            while not os.path.exists(filename):
                time.sleep(1)
                print("sleep")
            f.close()
            return readFile(filename)
    else:
       return readFile(filename)

def readFile(filename):
        file = open(filename, "rt")
        line = file.read()
        file.close()
        print(line)
        return line
        

def updateGPIO():
    for i in range (0,len(order)):
         pins[i] = GPIO.input(order[i])

def stateMath():
    sum = 0
    if GPIO.input(27) == 1:
        sum = 2**0
    if GPIO.input(26) == 1:
        sum = sum + 2**1
    if GPIO.input(25) == 1:
        sum = sum + 2**2
    if GPIO.input(24) == 1:
        sum = sum + 2**3
    msgAdd = "/state"+str(sum)
    print(msgAdd)
    return msgAdd





client = udp_client.UDPClient(checkIP(), 4559)

while True:
    msg = osc_message_builder.OscMessageBuilder(address = stateMath())
    updateGPIO()
    messages = ''
    for i in range (0,len(pins)):
        messages += str(pins[i])
    print(messages)
    msg.add_arg(messages)
    msg = msg.build()
    client.send(msg)
    time.sleep(0.3)
    os.system("clear")

